const _url = require('url');
const youtube_info = require('youtube-info');

let opt = false;
let con = {};

exports.set = (a) => {
    if (a.scKey) opt.scKey = a.scKey;
    else opt.scKey = false;
    if (a.ytKey) opt.ytKey = a.ytKey;
    else a.ytKey = false;
}

/* Returns nal if not a link
yt if youtube link
yt-playlist if youtube playlist
sc if soundcloud link
sc-playlist if soundcloud playlist
*/
exports.linkType = (url) => {
    url = _url.parse(url, true);
    if (/(?:www\.)?(?:youtu\.be|youtube\.com)/i.test(url.hostname)) {
        if (url.query.list) return 'yt-playlist';
        if (!url.query.v) return 'yt-be';
        return 'yt'
    }
    if (/(?:www\.)?(?:soundcloud\.com)/i.test(url.hostname)) {
        if (/\/sets\//i.test(url.path)) return 'sc-playlist';
        return 'sc';
    }
    return 'nal';
}

/* Create a voice channel connection
yourbot.joinVoiceChannel(channelID).then(connection => {
This must be run to initialize the bot into a voice channel
textChannel is the channel in which Next song messages will be sent
*/
exports.connect = (guildID, voiceChannel, textChannel, connection) => {
    con[guildId] = {
        voiceChannel,
        textChannel,
        connection
    };
}

exports.addSong = (guildID, url, user) => {
    return new Promise((res, rej) => {
        let type = exports.linkType(url);
        if (type === "yt-playlist" || type === "sc-playlist" || type === "nal") return rej('InvalidLink: Don\'t request playlists');
        if (type === "yt") {
            youtubeInfo(url).then(data => {
                
            })
        }

    });
}

function youtubeInfo(url) {
    return new Promise((res, rej) => {
      let type = linkType(url);
      if (type === "yt-playlist" || type === "sc-playlist" || type === "nal") return rej("InvalidLink: not youtube link")
      let id = _url.parse(url, true);
      if (type === "yt") id = id.query.v;
      if (type === "yt-be") id = id.path.slice(1);
      youtube_info(id, (err, data) => {
          if (err) return rej('Invalid Youtube ID');
          res(data);
      })
    })
}